import { jsxs as K, jsx as i } from "react/jsx-runtime";
import { useFloatingTree as Q, useFloatingNodeId as V, useListItem as W, useFloating as X, offset as Y, flip as Z, shift as $, autoUpdate as O, useClick as ee, useRole as te, useDismiss as se, useListNavigation as oe, useTypeahead as ne, useInteractions as ie, useMergeRefs as re, FloatingNode as ae, FloatingList as le, FloatingPortal as ce, FloatingFocusManager as ue, FloatingTree as fe } from "@floating-ui/react";
import de, { forwardRef as N, useState as f, useRef as v, useContext as me, useEffect as F } from "react";
import { MenuContext as I } from "./MenuContext.js";
const x = (e) => {
  if (typeof e == "string")
    return e;
  if (typeof e == "function")
    return e.displayName || e.name || "Component";
  if (typeof e == "object" && e !== null && "type" in e) {
    const t = e.type;
    if (typeof t == "function" || typeof t == "object")
      return t.displayName || t.name || "Component";
  }
  return "Element";
}, R = N(
  ({
    trigger: e,
    children: t,
    label: b = "Open menu",
    defaultPlacement: M = "bottom-start",
    onOpenChange: s,
    spacing: h,
    mode: k = "system",
    focusMode: P = "system",
    ...w
  }, E) => {
    const [o, d] = f(!1), [j, T] = f(!1), [c, u] = f(null), m = v([]), p = v([]), B = me(I), n = Q(), l = V(), L = W(), { floatingStyles: A, refs: y, context: r } = X({
      nodeId: l,
      open: o,
      onOpenChange: (a) => {
        d(a), s == null || s(a);
      },
      placement: M,
      strategy: "fixed",
      middleware: [Y({ mainAxis: 10 }), Z(), $()],
      whileElementsMounted: O
    }), D = ee(r, {
      event: "mousedown",
      toggle: !0,
      ignoreMouse: !1
    }), S = te(r, { role: "menu" }), _ = se(r, { bubbles: !0 }), H = oe(r, {
      listRef: m,
      activeIndex: c,
      nested: !1,
      onNavigate: u,
      loop: !0
    }), U = ne(r, {
      listRef: p,
      onMatch: o ? u : void 0,
      activeIndex: c
    }), { getReferenceProps: q, getFloatingProps: z, getItemProps: C } = ie([D, S, _, H, U]), g = x(e) === "Button" || x(e) === "ButtonIcon", G = g ? {
      noInternalClick: g,
      focusMode: P,
      mode: k,
      spacing: h
    } : {}, J = de.cloneElement(e, {
      ...G,
      "aria-label": b,
      "data-open": o ? "" : void 0,
      "data-focus-inside": j ? "" : void 0,
      ref: re([y.setReference, L.ref, E]),
      ...q(
        B.getItemProps({
          ...w
        })
      )
    });
    return F(() => {
      if (!n)
        return;
      function a() {
        d(!1), s == null || s(!1);
      }
      return n.events.on("click", a), () => {
        n.events.off("click", a);
      };
    }, [n, s]), F(() => {
      o && n && n.events.emit("menuopen", { nodeId: l });
    }, [n, o, l]), /* @__PURE__ */ K(ae, { id: l, children: [
      J,
      /* @__PURE__ */ i(
        I.Provider,
        {
          value: {
            activeIndex: c,
            setActiveIndex: u,
            getItemProps: C,
            setHasFocusInside: T,
            isOpen: o
          },
          children: /* @__PURE__ */ i(le, { elementsRef: m, labelsRef: p, children: o && /* @__PURE__ */ i(ce, { children: /* @__PURE__ */ i(
            ue,
            {
              context: r,
              modal: !1,
              initialFocus: 0,
              returnFocus: !0,
              children: /* @__PURE__ */ i(
                "div",
                {
                  ref: y.setFloating,
                  className: "rounded-md bg-surface-light p-4 shadow-sm shadow-border-dark outline-none sm:p-2",
                  style: A,
                  ...z(),
                  children: t
                }
              )
            }
          ) }) })
        }
      )
    ] });
  }
), pe = N((e, t) => /* @__PURE__ */ i(fe, { children: /* @__PURE__ */ i(R, { ...e, ref: t }) }));
pe.displayName = "Menu";
R.displayName = "MenuComponent";
export {
  pe as Menu,
  R as MenuComponent
};
