import { jsx as i, jsxs as g } from "react/jsx-runtime";
import { useListItem as I, useFloatingTree as C, useMergeRefs as k } from "@floating-ui/react";
import y from "clsx";
import * as a from "react";
import { MenuContext as M } from "./MenuContext.js";
const v = a.forwardRef(
  ({
    label: o,
    disabled: m,
    icon: s,
    raw: d = !1,
    children: c,
    ignoreClick: l = !1,
    ...e
  }, f) => {
    const u = a.useContext(M), b = I({ label: m ? null : o }), n = C(), x = k([b.ref, f]);
    return d && c ? /* @__PURE__ */ i(
      "div",
      {
        role: "menuitem",
        ...u.getItemProps({
          onClick(r) {
            var t;
            l || ((t = e.onClick) == null || t.call(e, r), n == null || n.events.emit("click"));
          }
        }),
        children: c
      }
    ) : /* @__PURE__ */ g(
      "button",
      {
        ...e,
        ref: x,
        role: "menuitem",
        className: "m-0 flex w-full rounded-md border border-transparent bg-none px-3 py-2 text-left text-base outline-none focus:border focus:border-border-medium focus:bg-surface-lighter focus:underline disabled:cursor-not-allowed disabled:text-copy-medium sm:py-1",
        tabIndex: 0,
        disabled: m,
        ...u.getItemProps({
          onClick(r) {
            var t;
            l || ((t = e.onClick) == null || t.call(e, r), n == null || n.events.emit("click"));
          },
          onFocus(r) {
            var t;
            (t = e.onFocus) == null || t.call(e, r), u.setHasFocusInside(!0);
          }
        }),
        children: [
          s,
          o && /* @__PURE__ */ i("span", { className: "pl-2", children: o })
        ]
      }
    );
  }
);
v.displayName = "MenuItem";
const h = ({ className: o, ...m }) => {
  const s = y(o, "my-1 border-t border-border-medium");
  return /* @__PURE__ */ i("div", { className: s, ...m });
};
export {
  v as MenuItem,
  h as MenuSeparator
};
